#ifndef GLASS_H_
#define GLASS_H_

/* visual specifiers */
enum {
	/* variadic list terminator */
	GLA_NONE,
	/* standalone */
	GLA_RGBA,
	GLA_FULLSCREEN,
	GLA_DOUBLE,
	GLA_STEREO,
	/* followed by value */
	GLA_RED,
	GLA_GREEN,
	GLA_BLUE,
	GLA_ALPHA,
	GLA_DEPTH,
	GLA_STENCIL
};

/* callbacks */
enum {
	GLA_EXPOSE,
	GLA_RESHAPE,
	GLA_KEYBOARD,
	GLA_BUTTON,
	GLA_MOTION,
	GLA_PASSIVE_MOTION,
	GLA_IDLE,
	GLA_SPACEBALL_MOTION,
	GLA_SPACEBALL_ROTATE,
	GLA_SPACEBALL_BUTTON,

	GLA_MAX_CB
};

/* gla_get */
enum {
	GLA_WIDTH,
	GLA_HEIGHT,
	GLA_DISPLAY,
	GLA_WINDOW
};

struct gla_visual {
	int fullscr;
	int attr[32];
};


#ifdef __cplusplus
extern "C" {
#endif

/* create and destroy a window */
int gla_create_win(int xsz, int ysz, struct gla_visual *gv);
void gla_destroy_win(void);

void gla_show_win(void);
void gla_hide_win(void);

void gla_win_title(const char *title);
/*void gla_win_icon();*/

/* enter/leave fullscreen */
void gla_fullscreen(void);
void gla_windowed(void);

void gla_visual(struct gla_visual *vis, ...);

void gla_callback(int cbidx, void (*func)());

void gla_redisplay(void);

void gla_swap_buffers(void);

int gla_event_proc(void);
void gla_main_loop(void);

void *gla_get(int what);

#ifdef __cplusplus
}
#endif

#endif	/* GLASS_H_ */
